Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Class CoordDisplay
   Inherits Label

   Private m_strFmt As String = "<Dd><Cp>"
   Private m_dblLat As Double = 0.0
   Private m_dblLon As Double = 0.0

   Public Sub New(ByVal strMessage As String)
      Me.AutoSize = True
      Me.Text = strMessage
   End Sub

   Private Sub UpdateDisplay()
      Me.Text = DmsFormat(m_dblLat, m_strFmt, True, False) & _
                "  " & _
                DmsFormat(m_dblLon, m_strFmt, False, False)
      Me.Refresh()
   End Sub

   Public Sub ClipboardCopy()
      Clipboard.SetDataObject(Me.Text)
   End Sub

   Property Format() As String
      Get
         Return m_strFmt
      End Get
      Set(ByVal Value As String)
         m_strFmt = Value
         UpdateDisplay()
      End Set
   End Property

   Public Property Latitude() As Double
      Get
         Return m_dblLat
      End Get
      Set(ByVal Value As Double)
         m_dblLat = Value
      End Set
   End Property

   Public Property Longitude() As Double
      Get
         Return m_dblLon
      End Get
      Set(ByVal Value As Double)
         m_dblLon = Value
         UpdateDisplay()
      End Set
   End Property

End Class

Class LocationSensor
   Inherits Form
   Public theCoords As New CoordDisplay("Welcome to the Mp2kMag location sensor")

   Public Sub New(ByVal strFmt As String)
      Me.Controls.Add(theCoords)
      Me.TopMost = True
      Me.Text = "Location Sensor"
      Me.ClientSize = theCoords.Size
      If strFmt <> "" Then
         Me.theCoords.Format = strFmt
      End If
   End Sub
End Class

Module DnClipPos
   Dim WithEvents oMpApp As MapPoint.Application
   Dim WithEvents oMap As MapPoint.Map
   Dim frmSensor As New LocationSensor(Microsoft.VisualBasic.Command())

   Sub Main()
      Try
         oMpApp = GetObject(, "MapPoint.Application")
      Catch ex As System.Exception
         oMpApp = New MapPoint.Application()
      End Try
      oMpApp.Visible = True
      oMpApp.UserControl = True
      oMap = oMpApp.ActiveMap

      System.Windows.Forms.Application.Run(frmSensor)
   End Sub

   Private Sub OnClick(ByVal Button As Integer, ByVal Shift As Integer, _
                          ByVal X As Integer, ByVal Y As Integer, ByRef Cancel As Boolean) _
                          Handles oMap.BeforeClick
      If Button <> MapPoint.GeoMouseButtonConstants.geoMiddleButton Then Exit Sub

      frmSensor.theCoords.ClipboardCopy()
   End Sub

   Private Sub OnMouseMove(ByVal Button As Integer, ByVal Shift As Integer, _
             ByVal X As Integer, ByVal Y As Integer) Handles oMap.MouseMove
      CalcPos(oMap, oMap.XYToLocation(X, Y), _
           frmSensor.theCoords.Latitude, _
           frmSensor.theCoords.Longitude)
   End Sub

   Public Sub oMpApp_BeforeClose(ByRef Cancel As Boolean) Handles oMpApp.BeforeClose
      oMap = Nothing
      oMpApp = Nothing
      frmSensor.Close()
   End Sub
End Module

